<template>
  <div>
    <Drawer
      :title="formTitle"
      v-model="modalVisible"
      width="720"
      :mask-closable="false"
      :styles="styles"
      @on-close="close"
    >
      <Form
        ref="formValidate"
        :model="formValidate"
        :rules="ruleValidate"
        :label-width="150"
        v-if="formValidate.details"
      >
        <FormItem label="栏目名称" prop="details.name">
           <Input
            v-model="formValidate.details.name"
            placeholder="Enter something"
          ></Input>
        </FormItem>
        <FormItem label="副标题" prop="details.title">
          <Input
            v-model="formValidate.details.title"
            placeholder="Enter something"
          ></Input>
        </FormItem>
        <FormItem label="是否显示为首页列表">
          <i-switch :value='formValidate.is_in_home_list===1?true:false'  @on-change='(value)=>{change(value,1)}'/>
        </FormItem>
         <FormItem label="是否在探索页显示">
          <i-switch :value='formValidate.is_in_discover_list===1?true:false'  @on-change='(value)=>{change(value,2)}'/>
        </FormItem>
        <FormItem label="展示图片" prop="details.res_show_pic">
          <UploadS ref="res_show_pic" v-model="formValidate.details.res_show_pic" />
        </FormItem>
        <FormItem label="封面模糊" prop="details.pic_blur">
            <InputNumber  v-model="formValidate.details.pic_blur"></InputNumber>
        </FormItem>
         <FormItem label="喜欢Icon">
          <UploadS ref="res_show_icon" v-model="formValidate.details.res_show_icon" />
        </FormItem>
      </Form>
      <div class="demo-drawer-footer">
        <Button style="margin-right: 8px" @click="close">取消</Button>
        <Button type="primary" @click="submit">保存</Button>
      </div>
    </Drawer>
  </div>
</template>
<script>
import UploadS from '@/view/common/upload.vue'
import {
  addCategories,
  editCategories
} from '@/api/categories'
const _requireBlur = { required: true, message: ' ', trigger: 'blur' }
const validatorPic = (rule, value, callback) => {
  if (!value) {
    callback(new Error(' '))
  } else {
    callback()
  }
}
const _requirePic = { required: true, message: ' ', trigger: 'blur', validator: validatorPic }
export default {
  name: 'AddTracks',
  props: {
    search: {
      type: Function,
      default: null
    },
    row: {
      type: Object,
      default: () => {}
    },
    visible: {
      type: Boolean,
      default: false
    }
  },
  components: {
    UploadS
  },
  data () {
    return {
      modalVisible: false,
      editMode: false,
      formTitle: '',
      styles: {
        height: 'calc(100% - 55px)',
        overflow: 'auto',
        paddingBottom: '53px',
        position: 'static'
      },
      formValidate: {},
      ruleValidate: {
        'details.name': [_requireBlur],
        'details.title': [_requireBlur],
        'details.res_show_pic': [_requirePic],
        'details.pic_blur': [_requirePic]
      }
    }
  },
  watch: {
    visible: {
      handler: function (val) {
        this.modalVisible = val
        if (val) {
          this.search()
        }
        this.formValidate = this.row
      },
      immediate: true
    },
    row: {
      handler: function (val) {
        console.log(val)
        if (val.id === 'add') {
          this.editMode = false
          this.formTitle = '新增栏目'
          this.formValidate = {
            details: {
              name: '',
              title: '',
              res_show_pic: '',
              res_show_icon: '',
              pic_blur: 1
            },
            is_in_home_lis: 0,
            is_in_discover_list: 1
          }
        } else {
          this.editMode = true
          this.formTitle = '编辑栏目'
          this.formValidate = val
        }
      },
      immediate: true
    }
  },
  methods: {
    submit () {
      if (this.$refs['res_show_pic'].getData()) {
        this.formValidate.details.res_show_pic = this.$refs['res_show_pic'].getData()
      }
      if (this.$refs['res_show_icon'].getData()) {
        this.formValidate.details.res_show_icon = this.$refs['res_show_icon'].getData()
      }
      console.log(this.formValidate)
      this.$refs['formValidate'].validate((valid) => {
        if (valid) {
          delete this.formValidate.created_at
          delete this.formValidate.deleted_at
          delete this.formValidate.updated_at
          let params = [this.formValidate]
          if (this.editMode) {
            editCategories(params).then((res) => {
              if (res.code === 200 && res.data.length > 0) {
                this.$Message.success('修改成功')
                this.close()
                this.search()
              }
            })
          } else {
            addCategories(params).then((res) => {
              if (res.code === 200 && res.data.length > 0) {
                this.$Message.success('新增成功')
                this.close()
                this.search()
              }
            })
          }
        } else {
          this.$Message.error('您还有必填项未填写')
        }
      })
    },
    change (val, type) {
      if (type === 1) {
        this.formValidate.is_in_home_lis = val ? 1 : 0
      }
      if (type === 2) {
        this.formValidate.is_in_discover_list = val ? 1 : 0
      }
    },
    close () {
      this.$emit('update:visible', false)
    }
  }
}
</script>
<style>
.demo-drawer-footer {
  width: 100%;
  position: absolute;
  bottom: 0;
  left: 0;
  border-top: 1px solid #e8e8e8;
  padding: 10px 16px;
  text-align: right;
  background: #fff;
}
</style>
